<?php

/**
 * Terms and Conditions
 *
 * @version 1.9 - 08.10.2011
 * @author Roland 'rosali' Liebl
 * @website http://myroundcube.googlecode.com
 * @licence GNU GPL
 *
 **/
 
/**
 *
 * Usage: http://mail4us.net/myroundcube/
 *
 * Notice: This plugin must run before all other plugins which are using
 *         the 'login_after' hook !!!
 *
 **/
 
class terms extends rcube_plugin
{
  public $task = '?(?!login|logout).*';
  
  function init()
  {
    $this->add_hook('render_page', array($this, 'terms_check'));
    $this->register_action('plugin.terms', array($this, 'terms_submitted'));
    $this->register_action('plugin.terms_show', array($this, 'terms_show'));
  }
  
  function terms_check($a){
    if(!isset($_POST['terms_agreed']) && empty($_SESSION['temp']) && $a['template'] != 'terms.terms' && empty($_SESSION['terms'])){
      $a = $this->terms_show($a);
    }    
    return $a;  
  }

  function terms_show($args)
  {
    $rcmail = rcmail::get_instance();
    $plugins = $rcmail->config->get('plugins');
    $plugins = array_flip($plugins);
    if(!isset($plugins['global_config'])){
      $this->load_config();
    }
    $this->add_texts('localization/', true);
    $renew = (int)strtotime($rcmail->config->get('terms_date','2011-01-01 00:00:00'));
    $auto = $rcmail->config->get('terms_renew');
    $old = $rcmail->config->get('termsagreed',0);
    if(
        $renew > $old || // terms have been updated
        (time() - ($auto * 86400) > $old && $auto != 0) || // renew agreement after x days
        $rcmail->config->get('terms_always',false) // always renew agreement
      ){
      $this->terms_css();
      if(file_exists('./plugins/terms/localization/' . $_SESSION['language'] . '/terms.html'))
        $_SESSION['terms_lang'] = $_SESSION['language'];
      else
        $_SESSION['terms_lang'] = 'en_US';

      if(!file_exists('./plugins/terms/localization/' . $_SESSION['terms_lang'] . '_terms.html')){
        $content = @file_get_contents('./plugins/terms/localization/terms.html.dist');
        @file_put_contents('./plugins/terms/localization/' . $_SESSION['terms_lang'] . '_terms.html', $content);
      }
      $rcmail->set_task('terms');
      $rcmail->output->send("terms.terms");
      die;
    }
    else{
      $_SESSION['terms'] = true;
    }
    return $args;
  }
  
  function terms_submitted()
  {
    $rcmail = rcmail::get_instance();
    
    if($rcmail->task == "logout")
      return $a;
    
    if(isset($_POST['terms_agreed'])){
      $_SESSION['terms'] = true;
      $settings = (array)unserialize($rcmail->user->data['preferences']);
      $settings = array_merge($settings,array('termsagreed' => time()));    
      $rcmail->user->save_prefs($settings);
      $this->log(sprintf("TERMS ACCEPTED: %s", $this->getVisitorIP() . ": " . $_SESSION['username']));
      $rcmail->output->redirect(array('task' => 'mail', 'action' => ''));
    }
    else{
      $rcmail->session->remove('terms');
      $this->terms_css();    
      $rcmail->output->show_message('terms.termsmustagree','error');
      $rcmail->kill_session();
      $rcmail->output->send('terms.logout');
      exit;
    }
    return;  
  }
  
  function terms_css()
  {
    $rcmail = rcmail::get_instance();    
    $skin  = $rcmail->config->get('skin','default');
    if(!file_exists("plugins/terms/skins/$skin/terms.css"))
      $skin = "default";
    $this->include_stylesheet('skins/' . $skin . '/terms.css');      
  }
  
  function getVisitorIP()
  { 
  
    //Regular expression pattern for a valid IP address 
    $ip_regexp = "/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})/"; 

    //Retrieve IP address from which the user is viewing the current page 
    if (isset ($HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"]) && !empty ($HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"])) { 
      $visitorIP = (!empty ($HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"])) ? $HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"] : ((!empty ($HTTP_ENV_VARS['HTTP_X_FORWARDED_FOR'])) ? $HTTP_ENV_VARS['HTTP_X_FORWARDED_FOR'] : @ getenv ('HTTP_X_FORWARDED_FOR')); 
    } 
    else { 
      $visitorIP = (!empty ($HTTP_SERVER_VARS['REMOTE_ADDR'])) ? $HTTP_SERVER_VARS['REMOTE_ADDR'] : ((!empty ($HTTP_ENV_VARS['REMOTE_ADDR'])) ? $HTTP_ENV_VARS['REMOTE_ADDR'] : @ getenv ('REMOTE_ADDR')); 
    } 

    return $visitorIP; 
  }
  
  function log($log)
  { 
    $rcmail = rcmail::get_instance();
    if($rcmail->config->get('terms_log',true)){
      write_log('terms',$log);
    }  
  }
}
?>